/// @addtogroup diffIncl
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file DiffInclusionLN.cpp
///
/// @author Daniel Wilczak
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file constitutes a part of the CAPD library, 
// distributed under the terms of the GNU General Public License.
// Consult  http://capd.wsb-nlu.edu.pl/ for details. 

#include "capd/diffIncl/MultiMap.h"
#include "capd/map/Map.hpp"
#include "capd/vectalg/vectalgLib.h"
#include "capd/map/mapLib.h"
#include "capd/diffIncl/DiffInclusionLN.hpp"

typedef capd::diffIncl::MultiMap<IMap> MultiMap;
typedef capd::diffIncl::MultiMap<IMapMD> MultiMapMD;

template class capd::diffIncl::DiffInclusionLN<MultiMap>;
template class capd::diffIncl::DiffInclusionLN<MultiMapMD>;


#ifdef __HAVE_MPFR__

typedef capd::diffIncl::MultiMap<IMpMap> MpMultiMap;
typedef capd::diffIncl::MultiMap<IMpMapMD> MpMultiMapMD;

template class capd::diffIncl::DiffInclusionLN<MpMultiMap>;
template class capd::diffIncl::DiffInclusionLN<MpMultiMapMD>;

#endif

/// @}
