/// @addtogroup dynsys
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file C2Taylor.cpp
///
/// @author Daniel Wilczak
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file constitutes a part of the CAPD library, 
// distributed under the terms of the GNU General Public License.
// Consult  http://capd.wsb-nlu.edu.pl/ for details. 

/* Author: Daniel Wilczak 2001-2005 */

#include "capd/dynsys/Taylor.hpp"
#include "capd/dynsys/BasicC2Taylor.hpp"
#include "capd/dynsys/C2Taylor.hpp"
#include "capd/vectalg/vectalgLib.h"
#include "capd/map/mapLib.h"

template class capd::dynsys::C2Taylor<IC2Map>;
template class capd::dynsys::BasicC2Taylor<IC2Map>;
template class capd::dynsys::BasicC2Taylor<DC2Map>;

template class capd::dynsys::BasicTaylor<IC2Map>;
template class capd::dynsys::BasicTaylor<DC2Map>;

template class capd::dynsys::C2Taylor<IC2MapMD>;
template class capd::dynsys::BasicC2Taylor<IC2MapMD>;
template class capd::dynsys::BasicC2Taylor<DC2MapMD>;

template class capd::dynsys::BasicTaylor<IC2MapMD>;
template class capd::dynsys::BasicTaylor<DC2MapMD>;

#ifdef __HAVE_MPFR__

template class capd::dynsys::C2Taylor<IMpC2Map>;
template class capd::dynsys::BasicC2Taylor<IMpC2Map>;
template class capd::dynsys::BasicC2Taylor<MpC2Map>;

template class capd::dynsys::BasicTaylor<IMpC2Map>;
template class capd::dynsys::BasicTaylor<MpC2Map>;

template class capd::dynsys::C2Taylor<IMpC2MapMD>;
template class capd::dynsys::BasicC2Taylor<IMpC2MapMD>;
template class capd::dynsys::BasicC2Taylor<MpC2MapMD>;

template class capd::dynsys::BasicTaylor<IMpC2MapMD>;
template class capd::dynsys::BasicTaylor<MpC2MapMD>;

#endif

/// @}
