/// @addtogroup map
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file CnCoeff.cpp
///
/// @author Daniel Wilczak
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file constitutes a part of the CAPD library, 
// distributed under the terms of the GNU General Public License.
// Consult  http://capd.wsb-nlu.edu.pl/ for details. 

#include "capd/map/CnCoeff.hpp"
#include "capd/interval/DoubleInterval.h"
#include "capd/vectalg/Vector.hpp"
#include "capd/vectalg/Matrix.hpp"
#include "capd/vectalg/Dimension.h"
#include "capd/vectalg/vectalgLib.h"

template class capd::map::CnContainer<double>;
template class capd::map::CnContainer<interval>;

template class capd::map::CnCoeff< DMatrixMD >;
template class capd::map::CnCoeff< IMatrixMD >;

template class capd::map::CnCoeff< DMatrix >;
template class capd::map::CnCoeff< IMatrix >;

#ifdef __HAVE_MPFR__

template class capd::map::CnContainer<Real>;
template class capd::map::CnContainer<MpInterval>;

template class capd::map::CnCoeff< MpMatrixMD >;
template class capd::map::CnCoeff< IMpMatrixMD >;

template class capd::map::CnCoeff< MpMatrix >;
template class capd::map::CnCoeff< IMpMatrix >;

#endif

/// @}
