/// @addtogroup map
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file CnMap.cpp
///
/// @author Daniel Wilczak
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file constitutes a part of the CAPD library, 
// distributed under the terms of the GNU General Public License.
// Consult  http://capd.wsb-nlu.edu.pl/ for details. 

#include "capd/map/CnMap.hpp"
#include "capd/vectalg/vectalgLib.h"

template class capd::map::CnMap<DMatrix,1>;
template class capd::map::CnMap<IMatrix,1>;

template class capd::map::CnMap<DMatrixMD,1>;
template class capd::map::CnMap<IMatrixMD,1>;

template class capd::map::CnMap<DMatrix,2>;
template class capd::map::CnMap<IMatrix,2>;

template class capd::map::CnMap<DMatrixMD,2>;
template class capd::map::CnMap<IMatrixMD,2>;

template class capd::map::CnMap<DMatrix,3>;
template class capd::map::CnMap<IMatrix,3>;

template class capd::map::CnMap<DMatrixMD,3>;
template class capd::map::CnMap<IMatrixMD,3>;

template class capd::map::CnMap<DMatrix,4>;
template class capd::map::CnMap<IMatrix,4>;

template class capd::map::CnMap<DMatrixMD,4>;
template class capd::map::CnMap<IMatrixMD,4>;

template class capd::map::CnMap<DMatrix,5>;
template class capd::map::CnMap<IMatrix,5>;

template class capd::map::CnMap<DMatrixMD,5>;
template class capd::map::CnMap<IMatrixMD,5>;

#ifdef __HAVE_MPFR__

  template class capd::map::CnMap<MpMatrix,1>;
  template class capd::map::CnMap<IMpMatrix,1>;

  template class capd::map::CnMap<MpMatrixMD,1>;
  template class capd::map::CnMap<IMpMatrixMD,1>;

  template class capd::map::CnMap<MpMatrix,2>;
  template class capd::map::CnMap<IMpMatrix,2>;

  template class capd::map::CnMap<MpMatrixMD,2>;
  template class capd::map::CnMap<IMpMatrixMD,2>;

  template class capd::map::CnMap<MpMatrix,3>;
  template class capd::map::CnMap<IMpMatrix,3>;

  template class capd::map::CnMap<MpMatrixMD,3>;
  template class capd::map::CnMap<IMpMatrixMD,3>;

  template class capd::map::CnMap<MpMatrix,4>;
  template class capd::map::CnMap<IMpMatrix,4>;

  template class capd::map::CnMap<MpMatrixMD,4>;
  template class capd::map::CnMap<IMpMatrixMD,4>;

  template class capd::map::CnMap<MpMatrix,5>;
  template class capd::map::CnMap<IMpMatrix,5>;

  template class capd::map::CnMap<MpMatrixMD,5>;
  template class capd::map::CnMap<IMpMatrixMD,5>;

#endif

/// @}
