/// @addtogroup poincare
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file TimeMap.cpp
///
/// @author Daniel Wilczak
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file constitutes a part of the CAPD library, 
// distributed under the terms of the GNU General Public License.
// Consult  http://capd.wsb-nlu.edu.pl/ for details. 


#include "capd/interval/DoubleInterval.h"
#include "capd/vectalg/Dimension.h"
#include "capd/vectalg/Matrix.hpp"
#include "capd/map/Map.hpp"
#include "capd/dynsys/Taylor.hpp"
#include "capd/poincare/TimeMap.hpp"
#include "capd/map/mapLib.h"
#include "capd/dynsys/dynsysLib.h"

template class capd::poincare::TimeMap<Taylor>;
template class capd::poincare::TimeMap<TaylorMD>;

template class capd::poincare::TimeMap<CnTaylor>;
template class capd::poincare::TimeMap<CnTaylorMD>;

#ifdef __HAVE_MPFR__

  template class capd::poincare::TimeMap<MpTaylor>;
  template class capd::poincare::TimeMap<MpTaylorMD>;

  template class capd::poincare::TimeMap<MpCnTaylor>;
  template class capd::poincare::TimeMap<MpCnTaylorMD>;

#endif

/// @}
