/// @addtogroup vectalg
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file Container.cpp
///
/// @author The CAPD Group
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file constitutes a part of the CAPD library, 
// distributed under the terms of the GNU General Public License.
// Consult  http://capd.wsb-nlu.edu.pl/ for details. 

#include <iostream>
#include "capd/vectalg/Dimension.h"
#include "capd/vectalg/Container.hpp"
#include "capd/interval/DoubleInterval.h"
#include "capd/interval/MpInterval.h"

namespace capd{ 
  namespace vectalg{
template class capd::vectalg::Container<double,DIM>;
template class capd::vectalg::Container<interval,DIM>;

template class capd::vectalg::Container<double,0>;
template class capd::vectalg::Container<interval,0>;

#ifdef __HAVE_MPFR__

typedef capd::multiPrec::MpfrClass Real;
typedef capd::intervals::Interval<Real> MpInterval;

template class capd::vectalg::Container<Real,DIM>;
template class capd::vectalg::Container<MpInterval,DIM>;

template class capd::vectalg::Container<Real,0>;
template class capd::vectalg::Container<MpInterval,0>;

#endif
  }
}
/// @}
