/// @addtogroup vectalg
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file IMatrixMD.cpp
///
/// @author The CAPD Group
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file constitutes a part of the CAPD library, 
// distributed under the terms of the GNU General Public License.
// Consult  http://capd.wsb-nlu.edu.pl/ for details. 


#include "capd/interval/DoubleInterval.h"
#include "capd/vectalg/Dimension.h"
#include "capd/vectalg/Vector.hpp"
#include "capd/vectalg/Matrix.hpp"

namespace capd{ 
  namespace vectalg{


template class Matrix<interval,0,0>;
template class RowVector<interval,0>;
template class ColumnVector<interval,0>;

template Matrix<interval,0,0> abs <interval,0,0> (const Matrix<interval,0,0>&);
template Matrix<interval,0,0> operator- <interval,0,0> (const Matrix<interval,0,0>&);
template Matrix<interval,0,0> operator+ <interval,0,0> (const Matrix<interval,0,0>&, const Matrix<interval,0,0>&);
template Matrix<interval,0,0> operator- <interval,0,0> (const Matrix<interval,0,0>&, const Matrix<interval,0,0>&);
template Matrix<interval,0,0> operator* <interval,0,0> (const Matrix<interval,0,0>&, const Matrix<interval,0,0>&);
template Vector<interval,0> operator* <interval,0,0> (const Matrix<interval,0,0>&, const Vector<interval,0>&);
template Matrix<interval,0,0> operator* <interval,0,0> (const Matrix<interval,0,0>&, const interval&);
template Matrix<interval,0,0> operator* <interval,0,0> (const interval&, const Matrix<interval,0,0>&);
template Matrix<interval,0,0> operator/ <interval,0,0> (const Matrix<interval,0,0>&, const interval&);
template Matrix<interval,0,0> operator+ <interval,0,0> (const Matrix<interval,0,0>&, const interval&);
template Matrix<interval,0,0> operator- <interval,0,0> (const Matrix<interval,0,0>&, const interval&);
template bool operator< <interval,0,0> (const Matrix<interval,0,0>&, const Matrix<interval,0,0>&);
template bool operator> <interval,0,0> (const Matrix<interval,0,0>&, const Matrix<interval,0,0>&);
template bool operator<= <interval,0,0> (const Matrix<interval,0,0>&, const Matrix<interval,0,0>&);
template bool operator>= <interval,0,0> (const Matrix<interval,0,0>&, const Matrix<interval,0,0>&);
template Matrix<interval,0,0> Transpose <interval,0,0> (const Matrix<interval,0,0>&);
template std::ostream &operator<< <interval,0,0> (std::ostream&, const Matrix<interval,0,0>&);
template std::istream &operator>> <interval,0,0> (std::istream&, Matrix<interval,0,0>&);

// intervalMatrix

typedef Matrix<interval,0,0> IMatrix;
template void split<IMatrix>(IMatrix&, IMatrix&);
template IMatrix midMatrix<IMatrix>(const IMatrix&);
template bool intersection<IMatrix>(const IMatrix&,const IMatrix&, IMatrix&);


// RowVector

template Vector<interval,0> operator+<interval,0>(
      const Vector<interval,0>&,
      const RowVector<interval,0>&
   );
template Vector<interval,0> operator+<interval,0>(
      const RowVector<interval,0>&,
      const Vector<interval,0>&
   );
template Vector<interval,0> operator+<interval,0>(
      const RowVector<interval,0>&,
      const RowVector<interval,0>&
   );

template Vector<interval,0> operator-<interval,0>(
      const Vector<interval,0>&,
      const RowVector<interval,0>&
   );
template Vector<interval,0> operator-<interval,0>(
      const RowVector<interval,0>&,
      const Vector<interval,0>&
   );
template Vector<interval,0> operator-<interval,0>(
      const RowVector<interval,0>&,
      const RowVector<interval,0>&
   );

template interval operator*<interval,0>(
      const Vector<interval,0>&,
      const RowVector<interval,0>&
   );
template interval operator*<interval,0>(
      const RowVector<interval,0>&,
      const Vector<interval,0>&
   );
template interval operator*<interval,0>(
      const RowVector<interval,0>&,
      const RowVector<interval,0>&
   );

template Vector<interval,0> operator-<interval,0>(const RowVector<interval,0>&);
template Vector<interval,0> operator*<interval,0,0>(
      const Matrix<interval,0,0>&, const RowVector<interval,0>&
   );

template Vector<interval,0> operator*<interval,0>(const interval&, const RowVector<interval,0>&);
template Vector<interval,0> operator*<interval,0>(const RowVector<interval,0>&, const interval&);
template Vector<interval,0> operator/<interval,0>(const RowVector<interval,0>&, const interval&);

template std::ostream& operator<< <interval,0>(std::ostream&, const RowVector<interval,0>&);


// ColumnVector

template Vector<interval,0> operator+<interval,0>(
      const Vector<interval,0>&,
      const ColumnVector<interval,0>&
   );
template Vector<interval,0> operator+<interval,0>(
      const ColumnVector<interval,0>&,
      const Vector<interval,0>&
   );
template Vector<interval,0> operator+<interval,0>(
      const ColumnVector<interval,0>&,
      const ColumnVector<interval,0>&
   );

template Vector<interval,0> operator-<interval,0>(
      const Vector<interval,0>&,
      const ColumnVector<interval,0>&
   );
template Vector<interval,0> operator-<interval,0>(
      const ColumnVector<interval,0>&,
      const Vector<interval,0>&
   );
template Vector<interval,0> operator-<interval,0>(
      const ColumnVector<interval,0>&,
      const ColumnVector<interval,0>&
   );

template interval operator*<interval,0>(
      const Vector<interval,0>&,
      const ColumnVector<interval,0>&
   );
template interval operator*<interval,0>(
      const ColumnVector<interval,0>&,
      const Vector<interval,0>&
   );
template interval operator*<interval,0>(
      const ColumnVector<interval,0>&,
      const ColumnVector<interval,0>&
   );

template Vector<interval,0> operator-<interval,0>(const ColumnVector<interval,0>&);
template Vector<interval,0> operator*<interval,0,0>(
      const Matrix<interval,0,0>&,
      const ColumnVector<interval,0>&
   );

template Vector<interval,0> operator*<interval,0>(const interval&, const ColumnVector<interval,0>&);
template Vector<interval,0> operator*<interval,0>(const ColumnVector<interval,0>&, const interval&);
template Vector<interval,0> operator/<interval,0>(const ColumnVector<interval,0>&, const interval&);

template std::ostream& operator<< <interval,0>(std::ostream&, const ColumnVector<interval,0>&);

}}  // end of namespace capd::vectalg

/// @}
