/// @addtogroup vectalg
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file MpMatrixMD.cpp
///
/// @author The CAPD Group
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file constitutes a part of the CAPD library, 
// distributed under the terms of the GNU General Public License.
// Consult  http://capd.wsb-nlu.edu.pl/ for details. 

#ifdef __HAVE_MPFR__

#include "capd/vectalg/Dimension.h"
#include "capd/vectalg/Vector.hpp"
#include "capd/vectalg/Matrix.hpp"
#include "capd/vectalg/vectalgLib.h"

namespace capd{ 
  namespace vectalg{


template class Matrix<Real,0,0>;
template class RowVector<Real,0>;
template class ColumnVector<Real,0>;

template Matrix<Real,0,0> abs <Real,0,0> (const Matrix<Real,0,0>&);
template Matrix<Real,0,0> operator- <Real,0,0> (const Matrix<Real,0,0>&);
template Matrix<Real,0,0> operator+ <Real,0,0> (const Matrix<Real,0,0>&, const Matrix<Real,0,0>&);
template Matrix<Real,0,0> operator- <Real,0,0> (const Matrix<Real,0,0>&, const Matrix<Real,0,0>&);
template Matrix<Real,0,0> operator* <Real,0,0> (const Matrix<Real,0,0>&, const Matrix<Real,0,0>&);
template Vector<Real,0> operator* <Real,0,0> (const Matrix<Real,0,0>&, const Vector<Real,0>&);
template Matrix<Real,0,0> operator* <Real,0,0> (const Matrix<Real,0,0>&, const Real&);
template Matrix<Real,0,0> operator* <Real,0,0> (const Real&, const Matrix<Real,0,0>&);
template Matrix<Real,0,0> operator/ <Real,0,0> (const Matrix<Real,0,0>&, const Real&);
template Matrix<Real,0,0> operator+ <Real,0,0> (const Matrix<Real,0,0>&, const Real&);
template Matrix<Real,0,0> operator- <Real,0,0> (const Matrix<Real,0,0>&, const Real&);
template bool operator< <Real,0,0> (const Matrix<Real,0,0>&, const Matrix<Real,0,0>&);
template bool operator> <Real,0,0> (const Matrix<Real,0,0>&, const Matrix<Real,0,0>&);
template bool operator<= <Real,0,0> (const Matrix<Real,0,0>&, const Matrix<Real,0,0>&);
template bool operator>= <Real,0,0> (const Matrix<Real,0,0>&, const Matrix<Real,0,0>&);
template Matrix<Real,0,0> Transpose <Real,0,0> (const Matrix<Real,0,0>&);
template std::ostream &operator<< <Real,0,0> (std::ostream&, const Matrix<Real,0,0>&);
template std::istream &operator>> <Real,0,0> (std::istream&, Matrix<Real,0,0>&);


// RowVector

template Vector<Real,0> operator+<Real,0>(
      const Vector<Real,0>&,
      const RowVector<Real,0>&
   );
template Vector<Real,0> operator+<Real,0>(
      const RowVector<Real,0>&,
      const Vector<Real,0>&
   );
template Vector<Real,0> operator+<Real,0>(
      const RowVector<Real,0>&,
      const RowVector<Real,0>&
   );

template Vector<Real,0> operator-<Real,0>(
      const Vector<Real,0>&,
      const RowVector<Real,0>&
   );
template Vector<Real,0> operator-<Real,0>(
      const RowVector<Real,0>&,
      const Vector<Real,0>&
   );
template Vector<Real,0> operator-<Real,0>(
      const RowVector<Real,0>&,
      const RowVector<Real,0>&
   );

template Real operator*<Real,0>(
      const Vector<Real,0>&,
      const RowVector<Real,0>&
   );
template Real operator*<Real,0>(
      const RowVector<Real,0>&,
      const Vector<Real,0>&
   );
template Real operator*<Real,0>(
      const RowVector<Real,0>&,
      const RowVector<Real,0>&
   );

template Vector<Real,0> operator-<Real,0>(const RowVector<Real,0>&);
template Vector<Real,0> operator*<Real,0,0>(
      const Matrix<Real,0,0>&, const RowVector<Real,0>&
   );

template Vector<Real,0> operator*<Real,0>(const Real&, const RowVector<Real,0>&);
template Vector<Real,0> operator*<Real,0>(const RowVector<Real,0>&, const Real&);
template Vector<Real,0> operator/<Real,0>(const RowVector<Real,0>&, const Real&);

template std::ostream& operator<< <Real,0>(std::ostream&, const RowVector<Real,0>&);


// ColumnVector

template Vector<Real,0> operator+<Real,0>(
      const Vector<Real,0>&,
      const ColumnVector<Real,0>&
   );
template Vector<Real,0> operator+<Real,0>(
      const ColumnVector<Real,0>&,
      const Vector<Real,0>&
   );
template Vector<Real,0> operator+<Real,0>(
      const ColumnVector<Real,0>&,
      const ColumnVector<Real,0>&
   );

template Vector<Real,0> operator-<Real,0>(
      const Vector<Real,0>&,
      const ColumnVector<Real,0>&
   );
template Vector<Real,0> operator-<Real,0>(
      const ColumnVector<Real,0>&,
      const Vector<Real,0>&
   );
template Vector<Real,0> operator-<Real,0>(
      const ColumnVector<Real,0>&,
      const ColumnVector<Real,0>&
   );

template Real operator*<Real,0>(
      const Vector<Real,0>&,
      const ColumnVector<Real,0>&
   );
template Real operator*<Real,0>(
      const ColumnVector<Real,0>&,
      const Vector<Real,0>&
   );
template Real operator*<Real,0>(
      const ColumnVector<Real,0>&,
      const ColumnVector<Real,0>&
   );

template Vector<Real,0> operator-<Real,0>(const ColumnVector<Real,0>&);
template Vector<Real,0> operator*<Real,0,0>(
      const Matrix<Real,0,0>&,
      const ColumnVector<Real,0>&
   );

template Vector<Real,0> operator*<Real,0>(const Real&, const ColumnVector<Real,0>&);
template Vector<Real,0> operator*<Real,0>(const ColumnVector<Real,0>&, const Real&);
template Vector<Real,0> operator/<Real,0>(const ColumnVector<Real,0>&, const Real&);

template std::ostream& operator<< <Real,0>(std::ostream&, const ColumnVector<Real,0>&);

}}  // end of namespace capd::vectalg

#endif // __HAVE_MPFR__

/// @}
