/// @addtogroup vectalg
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file MpVectorMD.cpp
///
/// @author The CAPD Group
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file constitutes a part of the CAPD library, 
// distributed under the terms of the GNU General Public License.
// Consult  http://capd.wsb-nlu.edu.pl/ for details. 

#ifdef __HAVE_MPFR__

#include <iostream>
#include "capd/vectalg/Vector.hpp"
#include "capd/vectalg/vectalgLib.h"
namespace capd{ 
  namespace vectalg{


template class Vector<Real,0>;

template Vector<Real,0> abs<Real,0> (const Vector<Real,0> &v);
template Vector<Real,0> operator- <Real,0> (const Vector<Real,0> &v);
template Vector<Real,0> operator+ <Real,0> (const Vector<Real,0> &v1,const Vector<Real,0> &v2);
template Vector<Real,0> operator- <Real,0> (const Vector<Real,0> &v1,const Vector<Real,0> &v2);
template Real operator* <Real,0> (const Vector<Real,0> &v1,const Vector<Real,0> &v2);

template Vector<Real,0> operator* <Real,Real,0> (const Vector<Real,0> &v,const Real &s);
template Vector<Real,0> operator* <Real,Real,0> (const Real &s,const Vector<Real,0> &v);
template Vector<Real,0> operator/ <Real,Real,0> (const Vector<Real,0> &v, const Real &s);

template Vector<Real,0> operator* <Real,long,0>(const Vector<Real,0> &v,const long &s);
template Vector<Real,0> operator* <Real,long,0>(const long &s,const Vector<Real,0> &v);
template Vector<Real,0> operator/ <Real,long,0>(const Vector<Real,0> &v, const long &s);

template Vector<Real,0> operator* <Real,int,0>(const Vector<Real,0> &v,const int &s);
template Vector<Real,0> operator* <Real,int,0>(const int &s,const Vector<Real,0> &v);
template Vector<Real,0> operator/ <Real,int,0>(const Vector<Real,0> &v, const int &s);

template Vector<Real,0> operator+ <Real,0> (const Vector<Real,0> &v,const Real &s);
template Vector<Real,0> operator- <Real,0> (const Vector<Real,0> &v,const Real &s);
template bool operator < <Real,0> (const Vector<Real,0> &v1,const Vector<Real,0> &v2);
template bool operator > <Real,0> (const Vector<Real,0> &v1,const Vector<Real,0> &v2);
template bool operator<= <Real,0> (const Vector<Real,0> &v1,const Vector<Real,0> &v2);
template bool operator>= <Real,0> (const Vector<Real,0> &v1,const Vector<Real,0> &v2);
template std::ostream &operator<< <Real,0> (std::ostream &out, const Vector<Real,0> &v);
template std::istream &operator>> <Real,0>(std::istream &inp, Vector<Real,0> &v);


}}  // end of namespace capd::vectalg

#endif // __HAVE_MPFR__

/// @}
