/// @addtogroup vectalg
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file Norm.cpp
///
/// @author The CAPD Group
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file constitutes a part of the CAPD library, 
// distributed under the terms of the GNU General Public License.
// Consult  http://capd.wsb-nlu.edu.pl/ for details. 

#include "capd/vectalg/vectalgLib.h"
#include "capd/vectalg/Norm.hpp"
#include "capd/vectalg/Vector.hpp"
#include "capd/vectalg/Matrix.hpp"

namespace capd{ 
  namespace vectalg{

template class capd::vectalg::Norm<IVector,IMatrix>;
template class capd::vectalg::EuclNorm<IVector,IMatrix>;
template class capd::vectalg::MaxNorm<IVector,IMatrix>;
template class capd::vectalg::SumNorm<IVector,IMatrix>;
template class capd::vectalg::EuclLNorm<IVector,IMatrix>;
template class capd::vectalg::MaxLNorm<IVector,IMatrix>;
template class capd::vectalg::SumLNorm<IVector,IMatrix>;

template class capd::vectalg::Norm<DVector,DMatrix>;
template class capd::vectalg::EuclNorm<DVector,DMatrix>;
template class capd::vectalg::MaxNorm<DVector,DMatrix>;
template class capd::vectalg::SumNorm<DVector,DMatrix>;
template class capd::vectalg::EuclLNorm<DVector,DMatrix>;
template class capd::vectalg::MaxLNorm<DVector,DMatrix>;
template class capd::vectalg::SumLNorm<DVector,DMatrix>;


template class capd::vectalg::Norm<IVectorMD,IMatrixMD>;
template class capd::vectalg::EuclNorm<IVectorMD,IMatrixMD>;
template class capd::vectalg::MaxNorm<IVectorMD,IMatrixMD>;
template class capd::vectalg::SumNorm<IVectorMD,IMatrixMD>;
template class capd::vectalg::EuclLNorm<IVectorMD,IMatrixMD>;
template class capd::vectalg::MaxLNorm<IVectorMD,IMatrixMD>;
template class capd::vectalg::SumLNorm<IVectorMD,IMatrixMD>;

template class capd::vectalg::Norm<DVectorMD,DMatrixMD>;
template class capd::vectalg::EuclNorm<DVectorMD,DMatrixMD>;
template class capd::vectalg::MaxNorm<DVectorMD,DMatrixMD>;
template class capd::vectalg::SumNorm<DVectorMD,DMatrixMD>;
template class capd::vectalg::EuclLNorm<DVectorMD,DMatrixMD>;
template class capd::vectalg::MaxLNorm<DVectorMD,DMatrixMD>;
template class capd::vectalg::SumLNorm<DVectorMD,DMatrixMD>;

#ifdef __HAVE_MPFR__

  template class capd::vectalg::Norm<IMpVector,IMpMatrix>;
  template class capd::vectalg::EuclNorm<IMpVector,IMpMatrix>;
  template class capd::vectalg::MaxNorm<IMpVector,IMpMatrix>;
  template class capd::vectalg::SumNorm<IMpVector,IMpMatrix>;
  template class capd::vectalg::EuclLNorm<IMpVector,IMpMatrix>;
  template class capd::vectalg::MaxLNorm<IMpVector,IMpMatrix>;
  template class capd::vectalg::SumLNorm<IMpVector,IMpMatrix>;

  template class capd::vectalg::Norm<MpVector,MpMatrix>;
  template class capd::vectalg::EuclNorm<MpVector,MpMatrix>;
  template class capd::vectalg::MaxNorm<MpVector,MpMatrix>;
  template class capd::vectalg::SumNorm<MpVector,MpMatrix>;
  template class capd::vectalg::EuclLNorm<MpVector,MpMatrix>;
  template class capd::vectalg::MaxLNorm<MpVector,MpMatrix>;
  template class capd::vectalg::SumLNorm<MpVector,MpMatrix>;


  template class capd::vectalg::Norm<IMpVectorMD,IMpMatrixMD>;
  template class capd::vectalg::EuclNorm<IMpVectorMD,IMpMatrixMD>;
  template class capd::vectalg::MaxNorm<IMpVectorMD,IMpMatrixMD>;
  template class capd::vectalg::SumNorm<IMpVectorMD,IMpMatrixMD>;
  template class capd::vectalg::EuclLNorm<IMpVectorMD,IMpMatrixMD>;
  template class capd::vectalg::MaxLNorm<IMpVectorMD,IMpMatrixMD>;
  template class capd::vectalg::SumLNorm<IMpVectorMD,IMpMatrixMD>;

  template class capd::vectalg::Norm<MpVectorMD,MpMatrixMD>;
  template class capd::vectalg::EuclNorm<MpVectorMD,MpMatrixMD>;
  template class capd::vectalg::MaxNorm<MpVectorMD,MpMatrixMD>;
  template class capd::vectalg::SumNorm<MpVectorMD,MpMatrixMD>;
  template class capd::vectalg::EuclLNorm<MpVectorMD,MpMatrixMD>;
  template class capd::vectalg::MaxLNorm<MpVectorMD,MpMatrixMD>;
  template class capd::vectalg::SumLNorm<MpVectorMD,MpMatrixMD>;

#endif

}}  // end of namespace capd::vectalg

/// @}
